initial commit
authorSimon Ruderich <simon@ruderich.org>
Sat, 23 Jan 2016 16:14:36 +0000 (17:14 +0100)
committerSimon Ruderich <simon@ruderich.org>
Sat, 23 Jan 2016 16:29:40 +0000 (17:29 +0100)
.gitignore [new file with mode: 0644]
Build.PL [new file with mode: 0644]
COPYING [new file with mode: 0644]
MANIFEST [new file with mode: 0644]
bin/fcscs [new file with mode: 0755]

diff --git a/.gitignore b/.gitignore
new file mode 100644 (file)
index 0000000..eaa8254
--- /dev/null
@@ -0,0 +1,7 @@
+/Build
+/META.json
+/META.yml
+/MYMETA.json
+/MYMETA.yml
+/_build/
+/blib/
diff --git a/Build.PL b/Build.PL
new file mode 100644 (file)
index 0000000..57f0ad4
--- /dev/null
+++ b/Build.PL
@@ -0,0 +1,43 @@
+#!/usr/bin/perl
+
+# Copyright (C) 2016  Simon Ruderich
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+
+use strict;
+use warnings;
+
+use Module::Build;
+
+my $build = Module::Build->new(
+    module_name        => 'fcscs',
+    dist_author        => 'Simon Ruderich <simon@ruderich.org>',
+    dist_version_from  => 'bin/fcscs',
+    license            => 'gpl', # gpl_3 is spec 2, not used by Module::Build
+    requires           => {
+                            'Curses' => 0,
+                            # Bundled with perl.
+                            'Encode' => 0,
+                            'Fcntl' => 0,
+                            'File::Temp' => 0,
+                            'I18N::Langinfo' => 0,
+                            'Pod::Usage' => 0,
+                            'Time::HiRes' => 0,
+                          },
+    configure_requires => {
+                            'Module::Build' => 0,
+                          },
+);
+$build->create_build_script;
diff --git a/COPYING b/COPYING
new file mode 100644 (file)
index 0000000..94a9ed0
--- /dev/null
+++ b/COPYING
@@ -0,0 +1,674 @@
+                    GNU GENERAL PUBLIC LICENSE
+                       Version 3, 29 June 2007
+
+ Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+                            Preamble
+
+  The GNU General Public License is a free, copyleft license for
+software and other kinds of works.
+
+  The licenses for most software and other practical works are designed
+to take away your freedom to share and change the works.  By contrast,
+the GNU General Public License is intended to guarantee your freedom to
+share and change all versions of a program--to make sure it remains free
+software for all its users.  We, the Free Software Foundation, use the
+GNU General Public License for most of our software; it applies also to
+any other work released this way by its authors.  You can apply it to
+your programs, too.
+
+  When we speak of free software, we are referring to freedom, not
+price.  Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+them if you wish), that you receive source code or can get it if you
+want it, that you can change the software or use pieces of it in new
+free programs, and that you know you can do these things.
+
+  To protect your rights, we need to prevent others from denying you
+these rights or asking you to surrender the rights.  Therefore, you have
+certain responsibilities if you distribute copies of the software, or if
+you modify it: responsibilities to respect the freedom of others.
+
+  For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must pass on to the recipients the same
+freedoms that you received.  You must make sure that they, too, receive
+or can get the source code.  And you must show them these terms so they
+know their rights.
+
+  Developers that use the GNU GPL protect your rights with two steps:
+(1) assert copyright on the software, and (2) offer you this License
+giving you legal permission to copy, distribute and/or modify it.
+
+  For the developers' and authors' protection, the GPL clearly explains
+that there is no warranty for this free software.  For both users' and
+authors' sake, the GPL requires that modified versions be marked as
+changed, so that their problems will not be attributed erroneously to
+authors of previous versions.
+
+  Some devices are designed to deny users access to install or run
+modified versions of the software inside them, although the manufacturer
+can do so.  This is fundamentally incompatible with the aim of
+protecting users' freedom to change the software.  The systematic
+pattern of such abuse occurs in the area of products for individuals to
+use, which is precisely where it is most unacceptable.  Therefore, we
+have designed this version of the GPL to prohibit the practice for those
+products.  If such problems arise substantially in other domains, we
+stand ready to extend this provision to those domains in future versions
+of the GPL, as needed to protect the freedom of users.
+
+  Finally, every program is threatened constantly by software patents.
+States should not allow patents to restrict development and use of
+software on general-purpose computers, but in those that do, we wish to
+avoid the special danger that patents applied to a free program could
+make it effectively proprietary.  To prevent this, the GPL assures that
+patents cannot be used to render the program non-free.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.
+
+                       TERMS AND CONDITIONS
+
+  0. Definitions.
+
+  "This License" refers to version 3 of the GNU General Public License.
+
+  "Copyright" also means copyright-like laws that apply to other kinds of
+works, such as semiconductor masks.
+
+  "The Program" refers to any copyrightable work licensed under this
+License.  Each licensee is addressed as "you".  "Licensees" and
+"recipients" may be individuals or organizations.
+
+  To "modify" a work means to copy from or adapt all or part of the work
+in a fashion requiring copyright permission, other than the making of an
+exact copy.  The resulting work is called a "modified version" of the
+earlier work or a work "based on" the earlier work.
+
+  A "covered work" means either the unmodified Program or a work based
+on the Program.
+
+  To "propagate" a work means to do anything with it that, without
+permission, would make you directly or secondarily liable for
+infringement under applicable copyright law, except executing it on a
+computer or modifying a private copy.  Propagation includes copying,
+distribution (with or without modification), making available to the
+public, and in some countries other activities as well.
+
+  To "convey" a work means any kind of propagation that enables other
+parties to make or receive copies.  Mere interaction with a user through
+a computer network, with no transfer of a copy, is not conveying.
+
+  An interactive user interface displays "Appropriate Legal Notices"
+to the extent that it includes a convenient and prominently visible
+feature that (1) displays an appropriate copyright notice, and (2)
+tells the user that there is no warranty for the work (except to the
+extent that warranties are provided), that licensees may convey the
+work under this License, and how to view a copy of this License.  If
+the interface presents a list of user commands or options, such as a
+menu, a prominent item in the list meets this criterion.
+
+  1. Source Code.
+
+  The "source code" for a work means the preferred form of the work
+for making modifications to it.  "Object code" means any non-source
+form of a work.
+
+  A "Standard Interface" means an interface that either is an official
+standard defined by a recognized standards body, or, in the case of
+interfaces specified for a particular programming language, one that
+is widely used among developers working in that language.
+
+  The "System Libraries" of an executable work include anything, other
+than the work as a whole, that (a) is included in the normal form of
+packaging a Major Component, but which is not part of that Major
+Component, and (b) serves only to enable use of the work with that
+Major Component, or to implement a Standard Interface for which an
+implementation is available to the public in source code form.  A
+"Major Component", in this context, means a major essential component
+(kernel, window system, and so on) of the specific operating system
+(if any) on which the executable work runs, or a compiler used to
+produce the work, or an object code interpreter used to run it.
+
+  The "Corresponding Source" for a work in object code form means all
+the source code needed to generate, install, and (for an executable
+work) run the object code and to modify the work, including scripts to
+control those activities.  However, it does not include the work's
+System Libraries, or general-purpose tools or generally available free
+programs which are used unmodified in performing those activities but
+which are not part of the work.  For example, Corresponding Source
+includes interface definition files associated with source files for
+the work, and the source code for shared libraries and dynamically
+linked subprograms that the work is specifically designed to require,
+such as by intimate data communication or control flow between those
+subprograms and other parts of the work.
+
+  The Corresponding Source need not include anything that users
+can regenerate automatically from other parts of the Corresponding
+Source.
+
+  The Corresponding Source for a work in source code form is that
+same work.
+
+  2. Basic Permissions.
+
+  All rights granted under this License are granted for the term of
+copyright on the Program, and are irrevocable provided the stated
+conditions are met.  This License explicitly affirms your unlimited
+permission to run the unmodified Program.  The output from running a
+covered work is covered by this License only if the output, given its
+content, constitutes a covered work.  This License acknowledges your
+rights of fair use or other equivalent, as provided by copyright law.
+
+  You may make, run and propagate covered works that you do not
+convey, without conditions so long as your license otherwise remains
+in force.  You may convey covered works to others for the sole purpose
+of having them make modifications exclusively for you, or provide you
+with facilities for running those works, provided that you comply with
+the terms of this License in conveying all material for which you do
+not control copyright.  Those thus making or running the covered works
+for you must do so exclusively on your behalf, under your direction
+and control, on terms that prohibit them from making any copies of
+your copyrighted material outside their relationship with you.
+
+  Conveying under any other circumstances is permitted solely under
+the conditions stated below.  Sublicensing is not allowed; section 10
+makes it unnecessary.
+
+  3. Protecting Users' Legal Rights From Anti-Circumvention Law.
+
+  No covered work shall be deemed part of an effective technological
+measure under any applicable law fulfilling obligations under article
+11 of the WIPO copyright treaty adopted on 20 December 1996, or
+similar laws prohibiting or restricting circumvention of such
+measures.
+
+  When you convey a covered work, you waive any legal power to forbid
+circumvention of technological measures to the extent such circumvention
+is effected by exercising rights under this License with respect to
+the covered work, and you disclaim any intention to limit operation or
+modification of the work as a means of enforcing, against the work's
+users, your or third parties' legal rights to forbid circumvention of
+technological measures.
+
+  4. Conveying Verbatim Copies.
+
+  You may convey verbatim copies of the Program's source code as you
+receive it, in any medium, provided that you conspicuously and
+appropriately publish on each copy an appropriate copyright notice;
+keep intact all notices stating that this License and any
+non-permissive terms added in accord with section 7 apply to the code;
+keep intact all notices of the absence of any warranty; and give all
+recipients a copy of this License along with the Program.
+
+  You may charge any price or no price for each copy that you convey,
+and you may offer support or warranty protection for a fee.
+
+  5. Conveying Modified Source Versions.
+
+  You may convey a work based on the Program, or the modifications to
+produce it from the Program, in the form of source code under the
+terms of section 4, provided that you also meet all of these conditions:
+
+    a) The work must carry prominent notices stating that you modified
+    it, and giving a relevant date.
+
+    b) The work must carry prominent notices stating that it is
+    released under this License and any conditions added under section
+    7.  This requirement modifies the requirement in section 4 to
+    "keep intact all notices".
+
+    c) You must license the entire work, as a whole, under this
+    License to anyone who comes into possession of a copy.  This
+    License will therefore apply, along with any applicable section 7
+    additional terms, to the whole of the work, and all its parts,
+    regardless of how they are packaged.  This License gives no
+    permission to license the work in any other way, but it does not
+    invalidate such permission if you have separately received it.
+
+    d) If the work has interactive user interfaces, each must display
+    Appropriate Legal Notices; however, if the Program has interactive
+    interfaces that do not display Appropriate Legal Notices, your
+    work need not make them do so.
+
+  A compilation of a covered work with other separate and independent
+works, which are not by their nature extensions of the covered work,
+and which are not combined with it such as to form a larger program,
+in or on a volume of a storage or distribution medium, is called an
+"aggregate" if the compilation and its resulting copyright are not
+used to limit the access or legal rights of the compilation's users
+beyond what the individual works permit.  Inclusion of a covered work
+in an aggregate does not cause this License to apply to the other
+parts of the aggregate.
+
+  6. Conveying Non-Source Forms.
+
+  You may convey a covered work in object code form under the terms
+of sections 4 and 5, provided that you also convey the
+machine-readable Corresponding Source under the terms of this License,
+in one of these ways:
+
+    a) Convey the object code in, or embodied in, a physical product
+    (including a physical distribution medium), accompanied by the
+    Corresponding Source fixed on a durable physical medium
+    customarily used for software interchange.
+
+    b) Convey the object code in, or embodied in, a physical product
+    (including a physical distribution medium), accompanied by a
+    written offer, valid for at least three years and valid for as
+    long as you offer spare parts or customer support for that product
+    model, to give anyone who possesses the object code either (1) a
+    copy of the Corresponding Source for all the software in the
+    product that is covered by this License, on a durable physical
+    medium customarily used for software interchange, for a price no
+    more than your reasonable cost of physically performing this
+    conveying of source, or (2) access to copy the
+    Corresponding Source from a network server at no charge.
+
+    c) Convey individual copies of the object code with a copy of the
+    written offer to provide the Corresponding Source.  This
+    alternative is allowed only occasionally and noncommercially, and
+    only if you received the object code with such an offer, in accord
+    with subsection 6b.
+
+    d) Convey the object code by offering access from a designated
+    place (gratis or for a charge), and offer equivalent access to the
+    Corresponding Source in the same way through the same place at no
+    further charge.  You need not require recipients to copy the
+    Corresponding Source along with the object code.  If the place to
+    copy the object code is a network server, the Corresponding Source
+    may be on a different server (operated by you or a third party)
+    that supports equivalent copying facilities, provided you maintain
+    clear directions next to the object code saying where to find the
+    Corresponding Source.  Regardless of what server hosts the
+    Corresponding Source, you remain obligated to ensure that it is
+    available for as long as needed to satisfy these requirements.
+
+    e) Convey the object code using peer-to-peer transmission, provided
+    you inform other peers where the object code and Corresponding
+    Source of the work are being offered to the general public at no
+    charge under subsection 6d.
+
+  A separable portion of the object code, whose source code is excluded
+from the Corresponding Source as a System Library, need not be
+included in conveying the object code work.
+
+  A "User Product" is either (1) a "consumer product", which means any
+tangible personal property which is normally used for personal, family,
+or household purposes, or (2) anything designed or sold for incorporation
+into a dwelling.  In determining whether a product is a consumer product,
+doubtful cases shall be resolved in favor of coverage.  For a particular
+product received by a particular user, "normally used" refers to a
+typical or common use of that class of product, regardless of the status
+of the particular user or of the way in which the particular user
+actually uses, or expects or is expected to use, the product.  A product
+is a consumer product regardless of whether the product has substantial
+commercial, industrial or non-consumer uses, unless such uses represent
+the only significant mode of use of the product.
+
+  "Installation Information" for a User Product means any methods,
+procedures, authorization keys, or other information required to install
+and execute modified versions of a covered work in that User Product from
+a modified version of its Corresponding Source.  The information must
+suffice to ensure that the continued functioning of the modified object
+code is in no case prevented or interfered with solely because
+modification has been made.
+
+  If you convey an object code work under this section in, or with, or
+specifically for use in, a User Product, and the conveying occurs as
+part of a transaction in which the right of possession and use of the
+User Product is transferred to the recipient in perpetuity or for a
+fixed term (regardless of how the transaction is characterized), the
+Corresponding Source conveyed under this section must be accompanied
+by the Installation Information.  But this requirement does not apply
+if neither you nor any third party retains the ability to install
+modified object code on the User Product (for example, the work has
+been installed in ROM).
+
+  The requirement to provide Installation Information does not include a
+requirement to continue to provide support service, warranty, or updates
+for a work that has been modified or installed by the recipient, or for
+the User Product in which it has been modified or installed.  Access to a
+network may be denied when the modification itself materially and
+adversely affects the operation of the network or violates the rules and
+protocols for communication across the network.
+
+  Corresponding Source conveyed, and Installation Information provided,
+in accord with this section must be in a format that is publicly
+documented (and with an implementation available to the public in
+source code form), and must require no special password or key for
+unpacking, reading or copying.
+
+  7. Additional Terms.
+
+  "Additional permissions" are terms that supplement the terms of this
+License by making exceptions from one or more of its conditions.
+Additional permissions that are applicable to the entire Program shall
+be treated as though they were included in this License, to the extent
+that they are valid under applicable law.  If additional permissions
+apply only to part of the Program, that part may be used separately
+under those permissions, but the entire Program remains governed by
+this License without regard to the additional permissions.
+
+  When you convey a copy of a covered work, you may at your option
+remove any additional permissions from that copy, or from any part of
+it.  (Additional permissions may be written to require their own
+removal in certain cases when you modify the work.)  You may place
+additional permissions on material, added by you to a covered work,
+for which you have or can give appropriate copyright permission.
+
+  Notwithstanding any other provision of this License, for material you
+add to a covered work, you may (if authorized by the copyright holders of
+that material) supplement the terms of this License with terms:
+
+    a) Disclaiming warranty or limiting liability differently from the
+    terms of sections 15 and 16 of this License; or
+
+    b) Requiring preservation of specified reasonable legal notices or
+    author attributions in that material or in the Appropriate Legal
+    Notices displayed by works containing it; or
+
+    c) Prohibiting misrepresentation of the origin of that material, or
+    requiring that modified versions of such material be marked in
+    reasonable ways as different from the original version; or
+
+    d) Limiting the use for publicity purposes of names of licensors or
+    authors of the material; or
+
+    e) Declining to grant rights under trademark law for use of some
+    trade names, trademarks, or service marks; or
+
+    f) Requiring indemnification of licensors and authors of that
+    material by anyone who conveys the material (or modified versions of
+    it) with contractual assumptions of liability to the recipient, for
+    any liability that these contractual assumptions directly impose on
+    those licensors and authors.
+
+  All other non-permissive additional terms are considered "further
+restrictions" within the meaning of section 10.  If the Program as you
+received it, or any part of it, contains a notice stating that it is
+governed by this License along with a term that is a further
+restriction, you may remove that term.  If a license document contains
+a further restriction but permits relicensing or conveying under this
+License, you may add to a covered work material governed by the terms
+of that license document, provided that the further restriction does
+not survive such relicensing or conveying.
+
+  If you add terms to a covered work in accord with this section, you
+must place, in the relevant source files, a statement of the
+additional terms that apply to those files, or a notice indicating
+where to find the applicable terms.
+
+  Additional terms, permissive or non-permissive, may be stated in the
+form of a separately written license, or stated as exceptions;
+the above requirements apply either way.
+
+  8. Termination.
+
+  You may not propagate or modify a covered work except as expressly
+provided under this License.  Any attempt otherwise to propagate or
+modify it is void, and will automatically terminate your rights under
+this License (including any patent licenses granted under the third
+paragraph of section 11).
+
+  However, if you cease all violation of this License, then your
+license from a particular copyright holder is reinstated (a)
+provisionally, unless and until the copyright holder explicitly and
+finally terminates your license, and (b) permanently, if the copyright
+holder fails to notify you of the violation by some reasonable means
+prior to 60 days after the cessation.
+
+  Moreover, your license from a particular copyright holder is
+reinstated permanently if the copyright holder notifies you of the
+violation by some reasonable means, this is the first time you have
+received notice of violation of this License (for any work) from that
+copyright holder, and you cure the violation prior to 30 days after
+your receipt of the notice.
+
+  Termination of your rights under this section does not terminate the
+licenses of parties who have received copies or rights from you under
+this License.  If your rights have been terminated and not permanently
+reinstated, you do not qualify to receive new licenses for the same
+material under section 10.
+
+  9. Acceptance Not Required for Having Copies.
+
+  You are not required to accept this License in order to receive or
+run a copy of the Program.  Ancillary propagation of a covered work
+occurring solely as a consequence of using peer-to-peer transmission
+to receive a copy likewise does not require acceptance.  However,
+nothing other than this License grants you permission to propagate or
+modify any covered work.  These actions infringe copyright if you do
+not accept this License.  Therefore, by modifying or propagating a
+covered work, you indicate your acceptance of this License to do so.
+
+  10. Automatic Licensing of Downstream Recipients.
+
+  Each time you convey a covered work, the recipient automatically
+receives a license from the original licensors, to run, modify and
+propagate that work, subject to this License.  You are not responsible
+for enforcing compliance by third parties with this License.
+
+  An "entity transaction" is a transaction transferring control of an
+organization, or substantially all assets of one, or subdividing an
+organization, or merging organizations.  If propagation of a covered
+work results from an entity transaction, each party to that
+transaction who receives a copy of the work also receives whatever
+licenses to the work the party's predecessor in interest had or could
+give under the previous paragraph, plus a right to possession of the
+Corresponding Source of the work from the predecessor in interest, if
+the predecessor has it or can get it with reasonable efforts.
+
+  You may not impose any further restrictions on the exercise of the
+rights granted or affirmed under this License.  For example, you may
+not impose a license fee, royalty, or other charge for exercise of
+rights granted under this License, and you may not initiate litigation
+(including a cross-claim or counterclaim in a lawsuit) alleging that
+any patent claim is infringed by making, using, selling, offering for
+sale, or importing the Program or any portion of it.
+
+  11. Patents.
+
+  A "contributor" is a copyright holder who authorizes use under this
+License of the Program or a work on which the Program is based.  The
+work thus licensed is called the contributor's "contributor version".
+
+  A contributor's "essential patent claims" are all patent claims
+owned or controlled by the contributor, whether already acquired or
+hereafter acquired, that would be infringed by some manner, permitted
+by this License, of making, using, or selling its contributor version,
+but do not include claims that would be infringed only as a
+consequence of further modification of the contributor version.  For
+purposes of this definition, "control" includes the right to grant
+patent sublicenses in a manner consistent with the requirements of
+this License.
+
+  Each contributor grants you a non-exclusive, worldwide, royalty-free
+patent license under the contributor's essential patent claims, to
+make, use, sell, offer for sale, import and otherwise run, modify and
+propagate the contents of its contributor version.
+
+  In the following three paragraphs, a "patent license" is any express
+agreement or commitment, however denominated, not to enforce a patent
+(such as an express permission to practice a patent or covenant not to
+sue for patent infringement).  To "grant" such a patent license to a
+party means to make such an agreement or commitment not to enforce a
+patent against the party.
+
+  If you convey a covered work, knowingly relying on a patent license,
+and the Corresponding Source of the work is not available for anyone
+to copy, free of charge and under the terms of this License, through a
+publicly available network server or other readily accessible means,
+then you must either (1) cause the Corresponding Source to be so
+available, or (2) arrange to deprive yourself of the benefit of the
+patent license for this particular work, or (3) arrange, in a manner
+consistent with the requirements of this License, to extend the patent
+license to downstream recipients.  "Knowingly relying" means you have
+actual knowledge that, but for the patent license, your conveying the
+covered work in a country, or your recipient's use of the covered work
+in a country, would infringe one or more identifiable patents in that
+country that you have reason to believe are valid.
+
+  If, pursuant to or in connection with a single transaction or
+arrangement, you convey, or propagate by procuring conveyance of, a
+covered work, and grant a patent license to some of the parties
+receiving the covered work authorizing them to use, propagate, modify
+or convey a specific copy of the covered work, then the patent license
+you grant is automatically extended to all recipients of the covered
+work and works based on it.
+
+  A patent license is "discriminatory" if it does not include within
+the scope of its coverage, prohibits the exercise of, or is
+conditioned on the non-exercise of one or more of the rights that are
+specifically granted under this License.  You may not convey a covered
+work if you are a party to an arrangement with a third party that is
+in the business of distributing software, under which you make payment
+to the third party based on the extent of your activity of conveying
+the work, and under which the third party grants, to any of the
+parties who would receive the covered work from you, a discriminatory
+patent license (a) in connection with copies of the covered work
+conveyed by you (or copies made from those copies), or (b) primarily
+for and in connection with specific products or compilations that
+contain the covered work, unless you entered into that arrangement,
+or that patent license was granted, prior to 28 March 2007.
+
+  Nothing in this License shall be construed as excluding or limiting
+any implied license or other defenses to infringement that may
+otherwise be available to you under applicable patent law.
+
+  12. No Surrender of Others' Freedom.
+
+  If conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot convey a
+covered work so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you may
+not convey it at all.  For example, if you agree to terms that obligate you
+to collect a royalty for further conveying from those to whom you convey
+the Program, the only way you could satisfy both those terms and this
+License would be to refrain entirely from conveying the Program.
+
+  13. Use with the GNU Affero General Public License.
+
+  Notwithstanding any other provision of this License, you have
+permission to link or combine any covered work with a work licensed
+under version 3 of the GNU Affero General Public License into a single
+combined work, and to convey the resulting work.  The terms of this
+License will continue to apply to the part which is the covered work,
+but the special requirements of the GNU Affero General Public License,
+section 13, concerning interaction through a network will apply to the
+combination as such.
+
+  14. Revised Versions of this License.
+
+  The Free Software Foundation may publish revised and/or new versions of
+the GNU General Public License from time to time.  Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+  Each version is given a distinguishing version number.  If the
+Program specifies that a certain numbered version of the GNU General
+Public License "or any later version" applies to it, you have the
+option of following the terms and conditions either of that numbered
+version or of any later version published by the Free Software
+Foundation.  If the Program does not specify a version number of the
+GNU General Public License, you may choose any version ever published
+by the Free Software Foundation.
+
+  If the Program specifies that a proxy can decide which future
+versions of the GNU General Public License can be used, that proxy's
+public statement of acceptance of a version permanently authorizes you
+to choose that version for the Program.
+
+  Later license versions may give you additional or different
+permissions.  However, no additional obligations are imposed on any
+author or copyright holder as a result of your choosing to follow a
+later version.
+
+  15. Disclaimer of Warranty.
+
+  THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
+APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
+HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY
+OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
+THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
+IS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
+ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
+
+  16. Limitation of Liability.
+
+  IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
+THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
+GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
+USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
+DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
+PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
+EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
+SUCH DAMAGES.
+
+  17. Interpretation of Sections 15 and 16.
+
+  If the disclaimer of warranty and limitation of liability provided
+above cannot be given local legal effect according to their terms,
+reviewing courts shall apply local law that most closely approximates
+an absolute waiver of all civil liability in connection with the
+Program, unless a warranty or assumption of liability accompanies a
+copy of the Program in return for a fee.
+
+                     END OF TERMS AND CONDITIONS
+
+            How to Apply These Terms to Your New Programs
+
+  If you develop a new program, and you want it to be of the greatest
+possible use to the public, the best way to achieve this is to make it
+free software which everyone can redistribute and change under these terms.
+
+  To do so, attach the following notices to the program.  It is safest
+to attach them to the start of each source file to most effectively
+state the exclusion of warranty; and each file should have at least
+the "copyright" line and a pointer to where the full notice is found.
+
+    <one line to give the program's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This program is free software: you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+Also add information on how to contact you by electronic and paper mail.
+
+  If the program does terminal interaction, make it output a short
+notice like this when it starts in an interactive mode:
+
+    <program>  Copyright (C) <year>  <name of author>
+    This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
+    This is free software, and you are welcome to redistribute it
+    under certain conditions; type `show c' for details.
+
+The hypothetical commands `show w' and `show c' should show the appropriate
+parts of the General Public License.  Of course, your program's commands
+might be different; for a GUI interface, you would use an "about box".
+
+  You should also get your employer (if you work as a programmer) or school,
+if any, to sign a "copyright disclaimer" for the program, if necessary.
+For more information on this, and how to apply and follow the GNU GPL, see
+<http://www.gnu.org/licenses/>.
+
+  The GNU General Public License does not permit incorporating your program
+into proprietary programs.  If your program is a subroutine library, you
+may consider it more useful to permit linking proprietary applications with
+the library.  If this is what you want to do, use the GNU Lesser General
+Public License instead of this License.  But first, please read
+<http://www.gnu.org/philosophy/why-not-lgpl.html>.
diff --git a/MANIFEST b/MANIFEST
new file mode 100644 (file)
index 0000000..ec97f27
--- /dev/null
+++ b/MANIFEST
@@ -0,0 +1,6 @@
+bin/fcscs
+Build.PL
+COPYING
+MANIFEST                       This list of files
+META.json
+META.yml
diff --git a/bin/fcscs b/bin/fcscs
new file mode 100755 (executable)
index 0000000..054842a
--- /dev/null
+++ b/bin/fcscs
@@ -0,0 +1,1232 @@
+#!/usr/bin/perl
+
+# fcscs - fast curses screen content select
+
+# Copyright (C) 2013-2016  Simon Ruderich
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+
+use strict;
+use warnings;
+
+use v5.10; # say, state
+
+use Encode ();
+use Fcntl ();
+use I18N::Langinfo ();
+
+use Curses ();
+
+our $VERSION = '0.01';
+
+
+=head1 NAME
+
+fcscs - fast curses screen content select
+
+=head1 SYNOPSIS
+
+B<fcscs> [I<options>] I<path/to/screen/capture/file>
+
+=head1 DESCRIPTION
+
+B<fcscs> is a small tool which allows quick selection of terminal screen
+contents (like URLs, paths, regex matches, etc.) and passes the selection to
+GNU Screen's or Tmux's buffer or any other program. The selection can then
+quickly be pasted, e.g. in the shell. Requires GNU Screen or Tmux. It's
+licensed under the GPL 3 or later.
+
+=head1 OPTIONS
+
+None so far.
+
+=head1 USAGE
+
+GNU Screen setup (add to F<~/.screenrc>):
+
+    bind ^B eval "hardcopy $HOME/.tmp/screen-fcscs" "screen fcscs $HOME/.tmp/screen-fcscs"
+
+Tmux setup (add to F<~/.tmux.conf>):
+
+    bind-key C-b capture-pane \; save-buffer ~/.tmp/tmux-fcscs \; delete-buffer \; new-window "fcscs ~/.tmp/tmux-fcscs"
+
+This requires a writable ~/.tmp directory. Adapt the mapping according to your
+preferences. Ensure these files are not readable by others as they can contain
+private data (umask or protected directory). B<fcscs> must be in your C<$PATH>
+for the above mappings to work.
+
+Pressing the configured mapping (Prefix Ctrl-B in this example) opens B<fcscs>
+in a new GNU screen/Tmux window. After selection, the content is either passed
+to external programs (e.g. for URLs) or copied to the paste buffer or directly
+pasted in your previous window and the new window is closed.
+
+To select a match just type its number. If the match is unique, the entry is
+automatically selected (e.g. you press 2 and there are only 19 matches). If
+there are multiple matches left (e.g. you press 1 and there are more than ten
+matches available), press return to select the current match (1 in this case)
+or another number to select the longer match. Use backspace to remove the last
+entered number.
+
+Press return before entering a number to select the last (lowest numbered)
+match. To abort without selecting any match either use "q".
+
+To change the selection mode (e.g. paths, files, etc.) use one of the mappings
+explained below. Per default URLs are selected, see options for a way to
+change this.
+
+I<NOTE>: When yanking (copying) a temporary file is used to pass the data to
+GNU screen/Tmux without exposing it to C<ps ux> or C<top>. However this may
+leak data if those temporary files are written to disk. To prevent this change
+your C<$TMP> accordingly to point to a memory-only location or encrypted
+storage.
+
+If no window appears, try running B<fcscs> manually to catch the error message
+and please report the bug:
+
+    fcscs /path/to/screen-or-tmux-fcscs-file
+
+=cut
+
+
+# CLASSES
+
+# Helper class for drawing on the screen using Curses.
+package Screen {
+    sub init {
+        my ($class, $encoding) = @_;
+
+        # Prefer strict UTF-8 handling (see perldoc Encode); just in case.
+        if (lc $encoding eq 'utf8') {
+            $encoding = 'UTF-8';
+        }
+        # Get Encode object to speed up decode()/encode().
+        my $encoding_object = Encode::find_encoding($encoding);
+        die "unsupported encoding '$encoding'" unless ref $encoding_object;
+
+        my $curses = Curses->new or die $!;
+
+        my $self = {
+            encoding        => $encoding,
+            encoding_object => $encoding_object,
+            curses          => $curses,
+            debug           => 0,
+            prompt          => {
+                flags => undef,
+                name  => undef,
+                value => undef,
+            },
+        };
+        bless $self, $class;
+
+        Curses::start_color;
+        # Allow default colors by passing -1 to init_pair. A default color is
+        # not drawn on screen thus allowing terminals with pseudo-transparency
+        # to use the transparent background in place of the default color.
+        Curses::use_default_colors;
+
+        Curses::cbreak;
+        Curses::noecho;
+        $self->cursor(0);
+
+        return $self;
+    }
+    sub deinit {
+        my ($self) = @_;
+
+        Curses::nocbreak;
+        Curses::echo;
+        $self->cursor(1);
+
+        Curses::endwin;
+        return;
+    }
+
+    # Convert between Perl's internal encoding and the terminal's encoding.
+    sub encode {
+        my ($self, $string) = @_;
+        return $self->{encoding_object}->encode($string);
+    }
+    sub decode {
+        my ($self, $string) = @_;
+        return eval { # returns undef on decode failure
+            $self->{encoding_object}->decode($string, Encode::FB_CROAK);
+        };
+    }
+
+    # Create attribute for the given fore-/background colors.
+    sub color_pair {
+        my ($self, $fg, $bg) = @_;
+
+        state $next_color_pair = 1; # must start at 1 for init_pair()
+
+        Curses::init_pair($next_color_pair, $fg, $bg);
+        return Curses::COLOR_PAIR($next_color_pair++);
+    }
+
+    # Draw a string which must fit in the current line. Wrapping/clipping is
+    # not supported and must be handled by the caller.
+    sub draw_simple {
+        my ($self, $y, $x, $attributes, $string) = @_;
+
+        die if $string =~ /\n/;
+        # FIXME: wide characters
+        die if $x + length $string > $self->width;
+
+        $self->{curses}->attron($attributes) if defined $attributes;
+        $self->{curses}->addstr($y, $x, $self->encode($string));
+        $self->{curses}->attroff($attributes) if defined $attributes;
+        return;
+    }
+    # Like draw_simple(), but the string is automatically clipped.
+    sub draw_clipped {
+        my ($self, $y, $x, $attributes, $string) = @_;
+
+        # FIXME: wide characters
+        $string = substr $string, 0, $self->width - $x;
+        $self->draw_simple($y, $x, $attributes, $string);
+        return;
+    }
+    sub draw {
+        my ($self, $y, $x, $attributes, $string) = @_;
+
+        die unless defined $string;
+
+        while (1) {
+            my $offset;
+            # We must print each line separately. Search for next newline or
+            # line end, whichever is closer.
+            if ($string =~ /\n/) {
+                $offset = $-[0];
+            }
+            # FIXME: wide characters
+            if ($x + length $string > $self->width) {
+                my $new_offset = $self->width - $x;
+                if (not defined $offset or $offset > $new_offset) {
+                    $offset = $new_offset;
+                }
+            }
+            last unless defined $offset;
+
+            # FIXME: wide characters
+            $self->draw_simple($y, $x, $attributes, substr $string, 0, $offset);
+
+            # Don't draw "\n" itself.
+            if ("\n" eq substr $string, $offset, 1) {
+                $offset++;
+            }
+
+            $string = substr $string, $offset;
+
+            $y++;
+            $x = 0;
+        }
+
+        $self->draw_simple($y, $x, $attributes, $string);
+        return $y;
+    }
+
+    sub draw_prompt {
+        my ($self, $config) = @_;
+
+        my $x = 0;
+        my $y = $self->height - 1;
+
+        # Clear line for better visibility.
+        $self->draw_simple($y, $x, undef, ' ' x $self->width);
+
+        # Draw prompt flags.
+        if (defined (my $s = $self->{prompt}{flags})) {
+            $s = "[$s]";
+            $self->draw_clipped($y, $x, $config->{attribute}{prompt_flags}, $s);
+            $x += length($s) + 1; # space between next element
+        }
+        # Draw prompt name.
+        if (defined (my $s = $self->{prompt}{name})) {
+            $s = "[$s]";
+            $self->draw_clipped($y, $x, $config->{attribute}{prompt_name}, $s);
+            $x += length($s) + 1;
+        }
+        # Draw prompt value, e.g. a search field.
+        if (defined (my $s = $self->{prompt}{value})) {
+            $self->draw_clipped($y, $x, undef, $s);
+            $x += length($s) + 1;
+        }
+        return;
+    }
+
+    sub draw_matches {
+        my ($self, $config, $matches_remove, $matches_add) = @_;
+
+        foreach (@{$matches_remove}) {
+            $self->draw($_->{y}, $_->{x}, Curses::A_NORMAL, $_->{string});
+        }
+
+        my $attr_id     = $config->{attribute}{match_id};
+        my $attr_string = $config->{attribute}{match_string};
+
+        foreach (@{$matches_add}) {
+            $self->draw($_->{y}, $_->{x}, $attr_string, $_->{string});
+            if (defined $_->{id}) {
+                $self->draw($_->{y}, $_->{x}, $attr_id, $_->{id});
+            }
+        }
+        return;
+    }
+
+    sub die {
+        my ($self, @args) = @_;
+
+        my $attr = $self->color_pair(Curses::COLOR_RED, -1) | Curses::A_BOLD;
+
+        # Clear the screen to improve visibility of the error message.
+        $self->{curses}->clear;
+
+        my $y = $self->draw(0, 0, $attr, "@args");
+
+        if ($self->{debug}) {
+            my $msg;
+            eval {
+                require Devel::StackTrace;
+            };
+            if ($@) {
+                $msg = "Devel::StackTrace missing, no stack trace.\n";
+            } else {
+                my $trace = Devel::StackTrace->new;
+                $msg = "Stack trace:\n" . $trace->as_string;
+            }
+            $y = $self->draw($y + 1, 0, Curses::A_NORMAL, $msg);
+        }
+
+        $self->draw($y + 1, 0, Curses::A_NORMAL,
+                    'Press any key to terminate fcscs.');
+        $self->refresh;
+
+        $self->getch;
+        $self->deinit;
+        exit 1;
+    }
+
+
+    sub prompt {
+        my ($self, %settings) = @_;
+
+        foreach (keys %settings) {
+            CORE::die if not exists $self->{prompt}{$_};
+            $self->{prompt}{$_} = $settings{$_};
+        }
+        return;
+    }
+
+    # Wrapper for Curses.
+    sub width   { return $Curses::COLS; }
+    sub height  { return $Curses::LINES; }
+    sub refresh { return $_[0]->{curses}->refresh; }
+    sub getch   { return $_[0]->{curses}->getch; }
+    sub cursor  { Curses::curs_set($_[1]); return; }
+}
+
+
+
+# FUNCTIONS
+
+sub debug {
+    my ($config, $module, @args) = @_;
+
+    say STDERR "$module: @args" if $config->{setting}{debug};
+    return;
+}
+
+
+sub prepare_input {
+    my ($screen, $input_ref) = @_;
+
+    # Make sure the input fits on the screen by removing the top lines if
+    # necessary.
+    splice @{$input_ref}, 0, -$screen->height;
+
+    # Pad each line with spaces to the screen width to correctly handle
+    # multi-line regexes.
+    # FIXME: wide characters
+    my @padded = map { sprintf '%-*s', $screen->width, $_ } @{$input_ref};
+
+    my $string = join "\n", @padded;
+    return {
+        string => $string,
+        lines  => $input_ref,
+        width  => $screen->width + 1,
+                  # + 1 = "\n", used in input_match_offset_to_coordinates
+    };
+}
+
+sub input_match_offset_to_coordinates {
+    my ($width, $offset) = @_;
+
+    die unless defined $offset;
+
+    my $y = int($offset / $width);
+    my $x = $offset - $y * $width;
+    return ($x, $y);
+}
+
+sub get_regex_matches {
+    my ($input, $regex) = @_;
+
+    my @matches;
+    while ($input->{string} =~ /$regex/g) {
+        my ($x, $y) = input_match_offset_to_coordinates($input->{width},
+                                                        $-[0]);
+        push @matches, { x => $x, y => $y, string => $1 };
+    }
+    return @matches;
+}
+
+
+sub run_command {
+    my ($config, $cmd) = @_;
+
+    debug $config, 'run_command', "running @{$cmd}";
+
+    my $exit = do {
+        # Perl's system() combined with a $SIG{__WARN__} which die()s has
+        # issues due to the fork. The die() in the __WARN__ handler doesn't
+        # die but the program continues after the system().
+        #
+        # If the forked process fails to exec (e.g. program not found) then
+        # the __WARN__ handler is called (because a warning is about to be
+        # displayed) and the die() should display a message and terminate the
+        # process. But due to the fork it doesn't terminate the parent process
+        # and instead changes the return value of system(); it's no longer -1
+        # which makes it impossible to detect that case.
+        #
+        # Perl < 5.18 (found in 5.14) doesn't setup $$ during system() which
+        # makes it impossible to detect if the handler was called from inside
+        # the child.
+        #
+        # Instead, just ignore any warnings during the system(). Thanks to
+        # mauke in #perl on Freenode (2013-10-29 23:30 CET) for the idea to
+        # use no warnings and anno for testing a more recent Perl version with
+        # a working $$.
+        no warnings;
+
+        system { $cmd->[0] } @{$cmd};
+    };
+    if ($exit != 0) {
+        my $msg;
+        if ($? == -1) {
+            $msg = 'failed to execute: ' . $!;
+        } elsif ($? & 127) {
+            $msg = 'killed by signal ' . ($? & 127);
+        } else {
+            $msg = 'exited with code ' . ($? >> 8);
+        }
+        die "system(@{$cmd}) $msg.";
+    }
+    return;
+}
+sub run_in_background {
+    my ($config, $sub) = @_;
+
+    debug $config, 'run_in_background', "running $sub";
+
+    my $pid = fork;
+    defined $pid or die $!;
+
+    if ($pid == 0) {
+        # The terminal multiplexer sends a SIGHUP to the process when it
+        # closes the window (because the parent process has exited).
+        local $SIG{HUP} = 'IGNORE';
+
+        # Necessary for GNU screen or it'll keep the window open until the
+        # paste command has run.
+        close STDIN  or die $!;
+        close STDOUT or die $!;
+        close STDERR or die $!;
+
+        # Double-fork to prevent zombies.
+        my $pid = fork;
+        defined $pid or die $!;
+        if ($pid == 0) { # child
+            $sub->();
+        }
+        exit;
+    }
+    waitpid $pid, 0 or die $!;
+    return;
+}
+
+
+sub select_match {
+    my ($name, $screen, $config, $input, $matches) = @_;
+
+    debug $config, 'select_match', 'started';
+
+    return if @{$matches} == 0;
+    # Don't return on initial run to give the user a chance to select another
+    # mode, e.g. to switch from URL selection to search selection.
+    if (@{$matches} == 1 and not $config->{state}->{initial}) {
+        return { match => $matches->[0] };
+    }
+    $config->{state}{initial} = 0;
+
+    my @sorted = sort { $b->{y} <=> $a->{y} or $b->{x} <=> $a->{x} } @{$matches};
+
+    my $i = 1;
+    foreach (@sorted) {
+        $_->{id} = $i++;
+    }
+
+    $screen->prompt(name => $name, value => undef);
+    $screen->draw_prompt($config);
+
+    $screen->draw_matches($config, [], $matches);
+    $screen->refresh;
+
+    my $number = 0;
+    while (1) {
+        my $char = $screen->getch;
+        if ($char =~ /^\d$/) {
+            $number = $number * 10 + $char;
+        } elsif ($char eq "\b" or $char eq "\x7f") { # backspace
+            $number = int($number / 10);
+        } elsif ($char eq "\n") {
+            if ($number == 0) { # number without selection matches last entry
+                $number = 1;
+            }
+            last;
+
+        # Selecting a new mode requires falling through into the main input
+        # loop and then starting the new mode.
+        } elsif (defined $config->{mapping}{mode}{$char}) {
+            $screen->draw_matches($config, $matches, []); # clear matches
+            return { key => $char };
+        # All other mappings stay in the current mode.
+        } elsif (defined (my $m = $config->{mapping}{simple}{$char})) {
+            $m->($char, $screen, $config, $input);
+            next;
+
+        } else {
+            next; # ignore unknown mappings
+        }
+
+        last if $number > 0 and $number * 10 > @{$matches}; # unique match
+
+        my @remaining = $number == 0
+                      ? @{$matches}
+                      : grep { $_->{id} =~ /^$number/ } @{$matches};
+        $screen->draw_matches($config, $matches, \@remaining);
+        $screen->refresh;
+    }
+
+    foreach (@{$matches}) {
+        return { match => $_ } if $_->{id} == $number;
+    }
+    debug $config, 'select_match', 'no match selected';
+    return { match => undef };
+}
+
+
+sub mapping_paste {
+    my ($key, $screen, $config, $input) = @_;
+
+    debug $config, 'mapping_paste', 'started';
+
+    $config->{state}{handler} = \&handler_paste;
+
+    $screen->prompt(flags => 'P'); # paste
+    $screen->draw_prompt($config);
+    $screen->refresh;
+
+    return {};
+}
+sub mapping_yank {
+    my ($key, $screen, $config, $input) = @_;
+
+    debug $config, 'mapping_yank', 'started';
+
+    $config->{state}{handler} = \&handler_yank;
+
+    $screen->prompt(flags => 'Y'); # yank
+    $screen->draw_prompt($config);
+    $screen->refresh;
+
+    return {};
+}
+
+
+sub mapping_mode_path {
+    my ($key, $screen, $config, $input) = @_;
+
+    debug $config, 'mapping_mode_path', 'started';
+
+    my @matches = get_regex_matches($input, $config->{regex}{path});
+    return {
+        select  => 'path select',
+        matches => \@matches,
+        handler => \&handler_yank,
+    };
+}
+sub mapping_mode_url {
+    my ($key, $screen, $config, $input) = @_;
+
+    debug $config, 'mapping_mode_url', 'started';
+
+    my @matches = get_regex_matches($input, $config->{regex}{url});
+    return {
+        select  => 'url select',
+        matches => \@matches,
+        handler => \&handler_url,
+    };
+}
+
+sub mapping_mode_search {
+    my ($key, $screen, $config, $input) = @_;
+
+    debug $config, 'mapping_mode_search', 'started';
+
+    $screen->cursor(1);
+
+    my $search = ''; # encoded
+    my @last_matches;
+    while (1) {
+        # getch doesn't return decoded characters but raw input bytes. Wait
+        # until the input character is complete.
+        my $value = $screen->decode($search);
+        $value = '' unless defined $value; # undef on decode failure
+
+        $screen->prompt(name => 'search', value => $value);
+        $screen->draw_prompt($config);
+        $screen->refresh;
+
+        my $char = $screen->getch;
+        # TODO: readline editing support
+        if ($char eq "\n") {
+            last;
+        } elsif ($char eq "\b" or $char eq "\x7f") { # backspace
+            # Remove a character, not a byte.
+            $search = $screen->decode($search);
+            chop $search;
+            $search = $screen->encode($search);
+        } else {
+            $search .= $char;
+            next unless defined $screen->decode($search);
+        }
+
+        my @matches;
+        if ($search ne '') {
+            my $case = '';
+            if (($config->{setting}{smartcase} and $search eq lc $search)
+                    or $config->{setting}{ignorecase}) {
+                $case = '(?i)';
+            }
+            # Ignore invalid regexps.
+            # TODO: display warning on error?
+            eval {
+                @matches = get_regex_matches($input, qr/($case$search)/);
+            };
+        }
+        $screen->draw_matches($config, \@last_matches, \@matches);
+        @last_matches = @matches;
+    }
+
+    $screen->cursor(0);
+
+    return {
+        select  => 'search',
+        matches => \@last_matches,
+        handler => \&handler_yank,
+    };
+}
+
+sub mapping_quit {
+    my ($key, $screen, $config, $input) = @_;
+
+    # Key is necessary to fall through to main event loop which then quits.
+    return { key => $key, quit => 1 };
+}
+
+
+sub handler_yank {
+    my ($screen, $config, $match) = @_;
+
+    debug $config, 'handler_yank', 'started';
+
+    require File::Temp;
+
+    # Use a temporary file to prevent leaking the yanked data to other users
+    # with the command line, e.g. ps aux or top.
+    my ($fh, $tmp) = File::Temp::tempfile(); # dies on its own
+    print $fh $screen->encode($match->{string});
+    close $fh or die $!;
+
+    if ($config->{setting}{multiplexer} eq 'screen') {
+        debug $config, 'handler_yank', 'using screen';
+
+        # GNU screen displays an annoying "Slurping X characters into buffer".
+        # Use 'msgwait 0' as a hack to disable it.
+        my $msgwait = $config->{setting}{screen_msgwait};
+        run_command($config, ['screen', '-X', 'msgwait', 0]);
+        run_command($config, ['screen', '-X', 'readbuf', $tmp]);
+        run_command($config, ['screen', '-X', 'msgwait', $msgwait]);
+    } elsif ($config->{setting}{multiplexer} eq 'tmux') {
+        debug $config, 'handler_yank', 'using tmux';
+
+        run_command($config, ['tmux', 'load-buffer', $tmp]);
+    } else {
+        die 'unsupported multiplexer';
+    }
+
+    unlink $tmp or die $!;
+    return;
+}
+sub handler_paste {
+    my ($screen, $config, $match) = @_;
+
+    debug $config, 'handler_paste', 'started';
+
+    require Time::HiRes;
+
+    my @cmd;
+    if ($config->{setting}{multiplexer} eq 'screen') {
+        debug $config, 'handler_paste', 'using screen';
+        @cmd = qw( screen -X paste . );
+    } elsif ($config->{setting}{multiplexer} eq 'tmux') {
+        debug $config, 'handler_paste', 'using tmux';
+        @cmd = qw( tmux paste-buffer );
+    } else {
+        die 'unsupported multiplexer';
+    }
+
+    run_in_background($config, sub {
+        # We need to get the data in the paste buffer before we can paste
+        # it.
+        handler_yank($screen, $config, $match);
+
+        # Sleep until we switch back to the current window.
+        Time::HiRes::usleep($config->{setting}{paste_sleep});
+
+        run_command($config, \@cmd);
+    });
+    return;
+}
+sub handler_url {
+    my ($screen, $config, $match) = @_;
+
+    debug $config, 'handler_url', 'started';
+
+    run_in_background($config, sub {
+        my $url = defined $match->{url}
+                ? $match->{url}
+                : $match->{string};
+
+        my @cmd = map { $screen->encode($_) } (
+            @{$config->{setting}{browser}},
+            $url,
+        );
+        run_command($config, \@cmd);
+    });
+    return;
+}
+
+
+
+# CONFIGURATION DEFAULTS
+
+=head1 CONFIGURATION
+
+fcscs is configured through F<~/.fcscsrc> or F<~/.config/fcscs/fcscsrc> which
+is a normal Perl script with all of Perl's usual features.
+
+All configuration values are stored in the hash C<%config>. All manually
+defined keys overwrite the default settings.
+
+A simple F<~/.fcscsrc> could look like this (for details about the used
+settings see below):
+
+    use strict;
+    use warnings;
+
+    use Curses; # for COLOR_* and A_* constants
+
+    our %config;
+
+    # Draw matches in blue.
+    $config{attribute}{match_string} = color_pair(COLOR_BLUE, -1);
+    # Enable Vim-like 'smartcase', ignore case until an upper character is
+    # searched.
+    $config{setting}{smartcase} = 1;
+
+    # Use chromium to open URLs if running under X, elinks otherwise.
+    if (defined $ENV{DISPLAY}) {
+        $config{setting}{browser} = ['chromium'];
+    } else {
+        $config{setting}{browser} = ['elinks'];
+    }
+
+    # Let fcscs know the file was loaded successfully.
+    1;
+
+=cut
+
+
+if (@ARGV != 1) {
+    require Pod::Usage;
+    Pod::Usage::pod2usage(2);
+}
+
+
+# Determine terminal encoding from the environment ($ENV{LANG} or similar).
+my $encoding = I18N::Langinfo::langinfo(I18N::Langinfo::CODESET);
+
+my $screen = Screen->init($encoding);
+
+# We must restore the screen before exiting.
+local $SIG{INT} = sub {
+    $screen->deinit;
+    exit 128 + 2;
+};
+# Make all warnings fatal to make sure they don't get lost (stderr is normally
+# not displayed).
+local $SIG{__WARN__} = sub {
+    $screen->die('warning', @_);
+};
+
+
+
+=head2 MAPPINGS
+
+I<NOTE>: Mappings are split in two categories: Mode mappings which change the
+selection and may receive additional input (e.g. a search string) and simple
+mappings which only change some value. Mode mappings are configured via
+C<$config{mapping}{mode}>, simple mappings via C<$config{mapping}{simple}>.
+
+The following mode mappings are available by default (the function to remap
+them in parentheses):
+
+=over
+
+=item B<f> select absolute/relative paths (C<\&mapping_mode_path>)
+
+=item B<u> select URLs (C<\&mapping_mode_url>)
+
+=item B</> search for regex to get selection (C<\&mapping_mode_search>)
+
+=item B<q> quit fcscs (C<\&mapping_quit>)
+
+=back
+
+The following simple mappings are available by default:
+
+=over
+
+=item B<p> enable pasting (C<\&mapping_paste>)
+
+=item B<y> enable yanking (copying) (C<\&mapping_yank>)
+
+=back
+
+All (single-byte) keys except numbers, backspace and return can be mapped.
+
+Unknown mappings are ignored when pressing keys.
+
+To remove a default mapping, delete it from the mapping hash.
+
+Example:
+
+    # Map 'p' to select paths, 'P' to enable pasting.
+    $config{mapping}{mode}{p} = \&mapping_mode_path;
+    $config{mapping}{simple}{P} = \&mapping_paste;
+
+    # Disable 'f' mapping.
+    delete $config{mapping}{mode}{f};
+
+=cut
+my %mapping_mode = (
+    f   => \&mapping_mode_path,
+    u   => \&mapping_mode_url,
+    '/' => \&mapping_mode_search,
+    q   => \&mapping_quit,
+);
+my %mapping_simple = (
+    p => \&mapping_paste,
+    y => \&mapping_yank,
+);
+
+=head2 ATTRIBUTES
+
+Attributes are used to style the output. They must be Curses attributes.
+Defaults in parentheses (foreground, background, attribute).
+
+=over
+
+=item B<match_id>      attribute for match numbers (red, default, bold)
+
+=item B<match_string>  attribute for matches (yellow, default, normal)
+
+=item B<prompt_name>   attribute for prompt name (standout)
+
+=item B<prompt_flags>  attribute for prompt flags (standout)
+
+=back
+
+Example:
+
+    # Draw prompt flags in bold red with default background color.
+    $config{attribute}{prompt_flags}
+        = Curses::A_BOLD
+        | color_pair(Curses::COLOR_RED, -1);
+
+=cut
+my %attribute = (
+    match_id     => $screen->color_pair(Curses::COLOR_RED, -1)
+                    | Curses::A_BOLD,
+    match_string => $screen->color_pair(Curses::COLOR_YELLOW, -1),
+    prompt_name  => Curses::A_STANDOUT,
+    prompt_flags => Curses::A_STANDOUT,
+);
+
+=head2 SETTINGS
+
+Defaults in parentheses.
+
+=over
+
+=item B<debug>          enable debug mode (redirect stderr when enabling) (C<0>)
+
+=item B<initial_mode>   start in this mode, must be a valid mode mapping (C<\&mapping_mode_url>)
+
+=item B<multiplexer>    set multiplexer ("screen" or "tmux") if not autodetected (C<undef>)
+
+=item B<ignorecase>     ignore case when searching (C<0>)
+
+=item B<smartcase>      ignore case unless one uppercase character is searched (C<1>)
+
+=item B<paste_sleep>    sleep x us before running paste command (C<100_000>)
+
+=item B<screen_msgwait> GNU Screen's msgwait variable, used when yanking (C<5>)
+
+=item B<browser>        browser command as array reference (C<['x-www-browser']>)
+
+=back
+
+Example:
+
+    # Select paths on startup instead of URLs.
+    $config{setting}{initial_mode} = \&mapping_mode_path;
+
+=cut
+my %setting = (
+    # options
+    debug          => 0,
+    initial_mode   => \&mapping_mode_url,
+    multiplexer    => undef,
+    ignorecase     => 0,
+    smartcase      => 1,
+    paste_sleep    => 100_000,
+    screen_msgwait => 5,
+    # commands
+    browser        => ['x-www-browser'],
+);
+
+=head2 REGEXPS
+
+=over
+
+=item B<url> used by C<\&mapping_mode_url()>
+
+=item B<path> used by C<\&mapping_mode_path()>
+
+=back
+
+Example:
+
+    # Select all non-whitespace characters when searching for paths.
+    $config{regex}{path} = qr{\S+};
+
+=cut
+my %regex = (
+    # Taken from urlview's default configuration file, thanks.
+    url  => qr{((?:(?:(?:http|https|ftp|gopher)|mailto):(?://)?[^ <>"\t]*|(?:www|ftp)[0-9]?\.[-a-z0-9.]+)[^ .,;\t\n\r<">\):]?[^, <>"\t]*[^ .,;\t\n\r<">\):])},
+    path => qr{(~?[a-zA-Z0-9_./-]*/[a-zA-Z0-9_./-]+)},
+);
+
+my %state = (
+    initial => 1, # used by select_match() for 'initial_mode'
+    handler => undef,
+);
+
+
+
+# CONFIGURATION "API"
+
+=head2 FUNCTIONS
+
+The following functions are available:
+
+    color_pair($fg, $bg)
+
+Create a new Curses attribute with the given fore- and background color.
+
+    mapping_mode_path()
+    mapping_mode_url()
+    mapping_mode_search()
+
+    mapping_paste()
+    mapping_yank()
+    mapping_quit()
+
+Used as mappings, see L</MAPPINGS> above.
+
+    handler_yank()
+    handler_paste()
+    handler_url()
+
+Used as handler to yank, paste selection or open URL in browser. They are
+either set by the matching mapping function (C<mapping_paste()>, etc.) or
+configured by the current mode.
+
+    get_regex_matches()
+    select_match()
+    run_command()
+    run_in_background()
+
+Helper functions when writing custom mappings, see the source for details.
+
+Example:
+
+    TODO
+
+=cut
+
+# All variables and functions which are usable by ~/.fcscsrc.
+package Fcscs {
+    our $screen; # "private"
+    our %config;
+
+    sub color_pair { return $screen->color_pair(@_); }
+
+    sub mapping_mode_path { return main::mapping_mode_path(@_); }
+    sub mapping_mode_url { return main::mapping_mode_url(@_); }
+    sub mapping_mode_search { return main::mapping_mode_search(@_); }
+
+    sub mapping_paste { return main::mapping_paste(@_); }
+    sub mapping_yank { return main::mapping_yank(@_); }
+    sub mapping_quit { return main::mapping_quit(@_); }
+
+    sub handler_yank { return main::handler_yank(@_); }
+    sub handler_paste { return main::handler_paste(@_); }
+    sub handler_url { return main::handler_url(@_); }
+
+    sub get_regex_matches { return main::get_regex_matches(@_); }
+    sub select_match { return main::select_match(@_); }
+
+    sub run_command { return main::run_command(@_); }
+    sub run_in_background { return main::run_in_background(@_); }
+}
+$Fcscs::screen = $screen;
+
+
+
+# LOAD USER CONFIG
+
+# Alias %config and %Fcscs::config. %config is less to type.
+our %config;
+local *config = \%Fcscs::config;
+
+$config{mapping}{mode}   = \%mapping_mode;
+$config{mapping}{simple} = \%mapping_simple;
+$config{attribute}       = \%attribute;
+$config{setting}         = \%setting;
+$config{regex}           = \%regex;
+$config{state}           = \%state;
+
+package Fcscs {
+    my @configs = ("$ENV{HOME}/.fcscsrc",
+                   "$ENV{HOME}/.config/fcscs/fcscsrc");
+    foreach my $path (@configs) {
+        my $decoded = $screen->decode($path);
+
+        # Load configuration file. Checks have a race condition if the home
+        # directory is writable by an attacker (but then the user is screwed
+        # anyway).
+        next unless -e $path;
+        if (not -O $path) {
+            $screen->die("Config '$decoded' not owned by current user!");
+        }
+        # Make sure the file is not writable by other users. Doesn't handle
+        # ACLs and see comment above about race conditions.
+        my @stat = stat $path or die $!;
+        my $mode = $stat[2];
+        if (($mode & Fcntl::S_IWGRP) or ($mode & Fcntl::S_IWOTH)) {
+            die "Config '$decoded' must not be writable by other users.";
+        }
+
+        my $result = do $path;
+        if (not $result) {
+            $screen->die("Failed to parse '$decoded': $@") if $@;
+            $screen->die("Failed to do '$decoded': $!") unless defined $result;
+            $screen->die("Failed to run '$decoded'.");
+        }
+
+        last; # success, don't load more files
+    }
+}
+$screen->{debug} = $config{setting}{debug};
+
+
+# MAIN
+
+eval {
+    # Auto-detect current multiplexer.
+    if (not defined $config{setting}{multiplexer}) {
+        if (defined $ENV{STY} and defined $ENV{TMUX}) {
+            die 'Found both $STY and $TMUX, set $config{setting}{multiplexer}.';
+        } elsif (defined $ENV{STY}) {
+            $config{setting}{multiplexer} = 'screen';
+        } elsif (defined $ENV{TMUX}) {
+            $config{setting}{multiplexer} = 'tmux';
+        } else {
+            die 'No multiplexer found.';
+        }
+    }
+
+    my $binmode = $encoding;
+    # GNU screen stores the screen dump for unknown reasons as ISO-8859-1
+    # instead of the currently active encoding.
+    if ($config{setting}{multiplexer} eq 'screen') {
+        $binmode = 'ISO-8859-1';
+    }
+
+    my @input_lines;
+    open my $fh, '<', $ARGV[0] or die $!;
+    binmode $fh, ":encoding($binmode)" or die $!;
+    while (<$fh>) {
+        chomp;
+        push @input_lines, $_;
+    }
+    close $fh or die $!;
+
+    my $input = prepare_input($screen, \@input_lines);
+
+    # Display original screen content.
+    my $y = 0;
+    foreach (@{$input->{lines}}) {
+        $screen->draw_simple($y++, 0, undef, $_);
+    }
+    $screen->refresh;
+
+
+    my $mapping = $config{setting}{initial_mode};
+
+    my $key;
+    while (1) {
+        if (not defined $mapping) {
+            $key = $screen->getch unless defined $key;
+            debug \%config, 'input', "got key '$key'";
+
+            $mapping = $config{mapping}{mode}{$key};
+            $mapping = $config{mapping}{simple}{$key} unless defined $mapping;
+            if (not defined $mapping) { # ignore unknown mappings
+                $key = undef;
+                next;
+            }
+        }
+
+        debug \%config, 'input', 'running mapping';
+        my $result = $mapping->($key, $screen, \%config, $input);
+        $mapping = undef;
+
+RESULT:
+        if (defined $result->{quit}) {
+            debug \%config, 'input', 'quitting';
+            last;
+        }
+        if (defined $result->{key}) {
+            $key = $result->{key}; # lookup another mapping
+            debug \%config, 'input', "processing new key: '$key'";
+            next;
+        }
+        if (defined $result->{select}) {
+            debug \%config, 'input', 'selecting match';
+            my $tmp = $result;
+            $result = select_match($result->{select},
+                                $screen, \%config, $input,
+                                $result->{matches});
+            $result->{handler} = $tmp->{handler};
+            goto RESULT; # reprocess special entries in result
+        }
+        if (defined $result->{match}) {
+            debug \%config, 'input', 'running handler';
+            my $handler = $config{state}{handler};                 # set by user
+            $handler = $result->{handler} unless defined $handler; # set by mapping
+            $handler = \&handler_yank     unless defined $handler; # fallback
+            $handler->($screen, \%config, $result->{match});
+            last;
+        }
+
+        $key = undef; # get next key from user
+    }
+};
+if ($@) {
+    $screen->die("$@");
+}
+
+$screen->deinit;
+
+__END__
+
+=head1 EXIT STATUS
+
+=over 4
+
+=item B<0>
+
+Success.
+
+=item B<1>
+
+An error occurred.
+
+=item B<2>
+
+Invalid arguments/options.
+
+=back
+
+=head1 AUTHOR
+
+Simon Ruderich E<lt>simon@ruderich.orgE<gt>
+
+=head1 LICENSE AND COPYRIGHT
+
+Copyright (C) 2013-2016 by Simon Ruderich
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see E<lt>http://www.gnu.org/licenses/E<gt>.
+
+=head1 SEE ALSO
+
+L<screen(1)>, L<tmux(1)>, L<urlview(1)>
+
+=cut